#include "user.h"
#include <qmessagebox.h>
#include <stdio.h>

void User::slot_cancel()
{
	parentWidget()->close();
}

void User::slot_ok()
{
	if(user_add->isOn())
	{
		if(host1->text().isEmpty())
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), tr("Please enter host."));
			return;
		}

		if(user1->text().isEmpty())
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), tr("Please enter user."));
			return;
		}

		if(password1->text().isEmpty())
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), tr("Please enter password."));
			return;
		}

		if(again1->text().isEmpty())
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), tr("Please enter password again."));
			return;
		}

		if(password1->text()!=again1->text())
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), tr("Passwords are not equal."));
			return;
		}

		char query[1000];

		sprintf(query,
				"insert into user values('%s',	
										 '%s',
										 password('%s'),
										 '%c',
										 '%c',
										 '%c',
										 '%c',
										 '%c',
										 '%c',
										 '%c',
										 '%c',
										 '%c',
										 '%c',
										 '%c',	
										 '%c',
										 '%c',
										 '%c')",
										 host1->text().latin1(),
										 user1->text().latin1(),
										 password1->text().latin1(),
										 select->isOn()?'Y':'N',
										 insert->isOn()?'Y':'N',
										 update->isOn()?'Y':'N',
										 _delete->isOn()?'Y':'N',
										 create->isOn()?'Y':'N',
										 drop->isOn()?'Y':'N',
										 reload->isOn()?'Y':'N',
										 shutdown->isOn()?'Y':'N',
										 process->isOn()?'Y':'N',
										 file->isOn()?'Y':'N',
										 grant->isOn()?'Y':'N',
										 references->isOn()?'Y':'N',
										 index->isOn()?'Y':'N',
										 alter->isOn()?'Y':'N');
		mysql_select_db(mysql,"mysql");

		if(!mysql_query(mysql,query))
		{
			mysql_reload(mysql);	
			QMessageBox::information(this, tr("MySQL Navigator"), user1->text()+QString("@")+host1->text()+QString(tr(" is created.")));
			clear();
		}
		else
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(mysql)));
			emit signal_error_log();
		}
	}
	else if(user_drop->isOn())
	{
		if(host1->text().isEmpty())
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), tr("Please enter host."));
			return;
		}

		if(user1->text().isEmpty())
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), tr("Please enter user."));
			return;
		}
		
		char query[1000];

		sprintf(query,"delete from user where user='%s' && host='%s'",
						user1->text().latin1(),
						host1->text().latin1());
		
		mysql_select_db(mysql,"mysql");

		if(!mysql_query(mysql,query))
		{
			mysql_reload(mysql);	
			QMessageBox::information(this, tr("MySQL Navigator"), user1->text()+QString("@")+host1->text()+QString(tr(" is droped.")));
			clear();
		}
		else
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(mysql)));
			emit signal_error_log();
		}
	}
	else if(user_alter->isOn())
	{
		char query[1000];

		if(host1->text().isEmpty())
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), tr("Please enter host."));
			return;
		}

		if(user1->text().isEmpty())
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), tr("Please enter user."));
			return;
		}
		if(password1->text().isEmpty())
		{
			sprintf(query,"update user set select_priv='%c',
										  insert_priv='%c',
										  update_priv='%c',
										  delete_priv='%c',
										  create_priv='%c',
										  drop_priv='%c',
										  reload_priv='%c',
										  shutdown_priv='%c',
										  process_priv='%c',
										  file_priv='%c',
										  grant_priv='%c',
										  references_priv='%c',
										  index_priv='%c',
										  alter_priv='%c'
										  where host='%s' && user='%s'",
										  select->isOn()?'Y':'N',
										  insert->isOn()?'Y':'N',
									      update->isOn()?'Y':'N',
										  _delete->isOn()?'Y':'N',
										  create->isOn()?'Y':'N',
										  drop->isOn()?'Y':'N',
										  reload->isOn()?'Y':'N',
										  shutdown->isOn()?'Y':'N',
										  process->isOn()?'Y':'N',
										  file->isOn()?'Y':'N',
										  grant->isOn()?'Y':'N',
										  references->isOn()?'Y':'N',
										  index->isOn()?'Y':'N',
										  alter->isOn()?'Y':'N',
										  host1->text().latin1(),
										  user1->text().latin1());
		
			mysql_select_db(mysql,"mysql");

			if(!mysql_query(mysql,query))
			{
				mysql_reload(mysql);	
				QMessageBox::information(this, tr("MySQL Navigator"), user1->text()+QString("@")+host1->text()+QString(tr(" is altered.")));
				clear();
			}
			else
			{
				QMessageBox::warning(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(mysql)));
				emit signal_error_log();
			}
			return;
		}
		else if(again1->text().isEmpty())
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), tr("Please enter password again."));
			return;
		}
		else if(password1->text()!=again1->text())
		{
			QMessageBox::warning(this, tr("MySQL Navigator"), tr("Passwords are not equal."));
			return;	
		}
		else
		{
			sprintf(query,"update user set password=password('%s'), 
										  select_priv='%c',
										  insert_priv='%c',
										  update_priv='%c',
										  delete_priv='%c',
										  create_priv='%c',
										  drop_priv='%c',
										  reload_priv='%c',
										  shutdown_priv='%c',
										  process_priv='%c',
										  file_priv='%c',
										  grant_priv='%c',
										  references_priv='%c',
										  index_priv='%c',
										  alter_priv='%c'
										  where host='%s' && user='%s'",
										  password1->text().latin1(), 
										  select->isOn()?'Y':'N',
										  insert->isOn()?'Y':'N',
									      update->isOn()?'Y':'N',
										  _delete->isOn()?'Y':'N',
										  create->isOn()?'Y':'N',
										  drop->isOn()?'Y':'N',
										  reload->isOn()?'Y':'N',
										  shutdown->isOn()?'Y':'N',
										  process->isOn()?'Y':'N',
										  file->isOn()?'Y':'N',
										  grant->isOn()?'Y':'N',
										  references->isOn()?'Y':'N',
										  index->isOn()?'Y':'N',
										  alter->isOn()?'Y':'N',
										  host1->text().latin1(),
										  user1->text().latin1());
		
			mysql_select_db(mysql,"mysql");

			if(!mysql_query(mysql,query))
			{
				mysql_reload(mysql);	
				QMessageBox::information(this, tr("MySQL Navigator"), user1->text()+QString("@")+host1->text()+QString(tr(" is altered.")));
				clear();
			}
			else
			{
				QMessageBox::warning(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(mysql)));
				emit signal_error_log();
			}
			return;

		}
	}
}

void User::slot_radio()
{
	if(user_add->isOn())
	{
		privilage_groupbox->setEnabled(TRUE);	
		password1->setEnabled(TRUE);
		again1->setEnabled(TRUE);
	}
	else if(user_drop->isOn())
	{
		privilage_groupbox->setEnabled(FALSE);	
		password1->setEnabled(FALSE);
		again1->setEnabled(FALSE);
	}
	else if(user_alter->isOn())
	{
		privilage_groupbox->setEnabled(TRUE);
		password1->setEnabled(TRUE);
		again1->setEnabled(TRUE);
	}
}

void User::clear()
{
	all->setChecked(FALSE);
	host1->setText("");
	user1->setText("");
	password1->setText("");
	again1->setText("");
	select->setOn(FALSE);
	insert->setOn(FALSE);
	update->setOn(FALSE);
	_delete->setOn(FALSE);
	create->setOn(FALSE);
	drop->setOn(FALSE);
	reload->setOn(FALSE);
	shutdown->setOn(FALSE);
	process->setOn(FALSE);
	file->setOn(FALSE);
	grant->setOn(FALSE);
	references->setOn(FALSE);
	index->setOn(FALSE);
	alter->setOn(FALSE);
}

void User::slot_select_all()
{
	if(all->isOn())
	{
		select->setOn(TRUE);
		insert->setOn(TRUE);
		update->setOn(TRUE);
		_delete->setOn(TRUE);
		create->setOn(TRUE);
		drop->setOn(TRUE);
		reload->setOn(TRUE);
		shutdown->setOn(TRUE);
		process->setOn(TRUE);
		file->setOn(TRUE);
		grant->setOn(TRUE);
		references->setOn(TRUE);
		index->setOn(TRUE);
		alter->setOn(TRUE);
	}
	else
	{
		select->setOn(FALSE);
		insert->setOn(FALSE);
		update->setOn(FALSE);
		_delete->setOn(FALSE);
		create->setOn(FALSE);
		drop->setOn(FALSE);
		reload->setOn(FALSE);
		shutdown->setOn(FALSE);
		process->setOn(FALSE);
		file->setOn(FALSE);
		grant->setOn(FALSE);
		references->setOn(FALSE);
		index->setOn(FALSE);
		alter->setOn(FALSE);
	}
}
