#include "xport.h"
#include <qcombobox.h>
#include <qpixmap.h>
#include <qpushbutton.h>

void Xport::signal_connect()
{
	import_button->setText("...");
	export_button->setText("...");

	connect((const QObject *)close, SIGNAL(clicked()), (const QObject *)this, SLOT(slot_close()));
	connect((const QObject *)export_button, SIGNAL(clicked()), (const QObject *)this, SLOT(slot_export()));
	connect((const QObject *)import_button, SIGNAL(clicked()), (const QObject *)this, SLOT(slot_import()));
	connect((const QObject *)fire, SIGNAL(clicked()), (const QObject *)this, SLOT(slot_fire()));
	connect((const QObject *)export_database, SIGNAL(activated(int)), this, SLOT(slot_list_export_table(int)));
}

void Xport::set_database()
{
	MYSQL_RES *result;
	MYSQL_ROW row;

	import_database->clear();
	export_database->clear();

	result = mysql_list_dbs(mysql,NULL);

	if(result == NULL)
	{
		debug("mysql_list_dbs failed");
		return;
	}

	while((row = mysql_fetch_row(result)))
	{
		import_database->insertItem(row[0]);
		export_database->insertItem(row[0]);
	}
	mysql_free_result(result);
	
	return;
}
